/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};
var saveAsFilePath; // undefined initially

//
/*[ Start of file stream code
var mystream;
var mywriter;
var myTextEnc = new TextEncoder();
var saveStart = function(filename) {
    if (!filename) filename = 'mydata.csv';
    mystream = streamSaver.createWriteStream(filename);
    mywriter = mystream.getWriter();
	saveData(myTextEnc.encode('Temperature, Time\n'));
};
var saveStop = function() {
    if (mywriter) {
        mywriter.close();
        mywriter = null;
    }
};
var saveAbort = function() {
    if (mywriter){
        mywriter.abort('reason');
        mywriter = null;
    }
};
var saveData = function(data) {
    if (mywriter) {
        mywriter.write(data);
    }
};
window.addEventListener('unload', (event) => {
//  console.log('unload', event);
  saveAbort(); // seems ok but please test.
});
var saveDummyData = function() {
    // To save textual data use TextEncoder to encode the data first
    var my_text = 'abcdef 01234 ABCDEF 56789 some text to go ... done';
    var myary = myTextEnc.encode(my_text + '\n');
    saveData(myary);
    // To save byte array data like below, no need to encode it.
    //saveData([1,2,3,4,5,6,7,8,9,10, 100,101]);  
};
*/// End of file stream code ]


var convertTemp = function(value, isToCelsius) {
    var result = value;
    if (isToCelsius) {
        result = (value - 32) / 1.8;
    } else {
        result = (value * 1.8) + 32;
    }
    return result;
};

var getF = function(value){
	return (value * 1.8) + 32;
};
var getC = function(value){
    return (value - 32) / 1.8;
};
var twosComp = function(value){
      var result = value-256;
      return result;
};


var RegTemp2Deci = function(HB,LB){
            var result = 0;
            HB_num = parseFloat(HB);
            LB_num = parseFloat(LB)/16;
            if(RangeFLAG ===0){
                if(HB>127){
                HB_num = twosComp(HB_num);
                }
                result = HB_num +LB_num;
            }
            else{
                result = parseFloat(HB_num + LB_num)-64;
            }
            if(tempScale === "F"){
                result = getF(result);
                result = Math.round((result*10000))/10000;
            }
            return result;
    
};

var RegTemp2Deci_offset = function(HB,LB){
            var result = 0;
            HB_num = parseFloat(HB);
            LB_num = parseFloat(LB)/16;
            if(HB>127){
                HB_num = twosComp(HB_num);
                }
                result = HB_num +LB_num;
            if(tempScale === "F"){
                result = Math.round((result*1.8)*10000)/10000;
            }
            return result;
    
};





var DeciTemp2RegValue_High = function(value){
            if(tempScale === "F"){
                value = getC(value);
            }
            if(RangeFLAG ===1){
                value = value+64;
            }
            var result = Math.floor(parseFloat(value));
            return result;
    
};


var DeciTemp2RegValue_Low = function(value){
            if(tempScale === "F"){
                value = getC(value);
            }            
            var result = (parseFloat(value) - Math.floor(parseFloat(value)));
            result = result*16;
            return result;
    
};

var DeciTemp2RegValue_Low_offset = function(value){
            if(tempScale === "F"){
                value = Math.round((value/1.8)*10000)/10000;
            }            
            var result = (parseFloat(value) - Math.floor(parseFloat(value)));
            result = result*16;
            return result;
    
};

var DeciTemp2RegValue_High_offset = function(value){
            if(tempScale === "F"){
                value =  Math.round((value/1.8)*10000)/10000;
            }
            var result = Math.floor(parseFloat(value));
            return result;
    
};

var tempScale = "C";
var newconnection = false;


//Extended values
var RangeFLAG = 0;
var C_Range_low = -64;
var C_Range_high = 191;
var F_Range_low = -83.2;
var F_Range_high = 375.8;
var Range_low = -64;
var Range_high = 191;
var C_Slider_labels = '-64,-32,0,32,64,96,128,160,191';
var F_Slider_labels = '-83.2,32,147.2,262.4,375.8';
//Standard Values
var C_Range_low_standard = 0;
var C_Range_high_standard = 127;
var F_Range_low_standard = 32;
var F_Range_high_standard = 260.6;
var Range_low_standard = 0;
var Range_high_standard = 127;
var C_Slider_labels_standard = '0,16,32,48,64,80,96,112,127';
var F_Slider_labels_standard = '32,89.6,147.2,204.8,260.6';




var C_Slider_increment = 0.0625;
var F_Slider_increment = 0.1125;

if(tempScale === "C"){
    Range_low = C_Range_low;
    Range_high = C_Range_high;
}
else{
    Range_low = F_Range_low;
    Range_high = F_Range_high;
}

var sampleTimeArray = [];   // Array for time-samples
var saveText = function(fname, text) {
    var blob = new Blob([text], {
        type: 'text/plain;charset=utf-8'
    });
    saveAs(blob, fname);

    return false;
};


function convertTimestamp(timestamp) {
    var d = new Date(timestamp), // Convert the passed timestamp to milliseconds
        yyyy = d.getFullYear(),
        mm = ('0' + (d.getMonth() + 1)).slice(-2), // Months are zero based. Add leading 0.
        dd = ('0' + d.getDate()).slice(-2), // Add leading 0.
        hh = d.getHours(),
        h = hh,
        min = ('0' + d.getMinutes()).slice(-2), // Add leading 0.
        ampm = 'AM',
        time;

    if (hh > 12) {
        h = hh - 12;
        ampm = 'PM';
    } else if (hh === 12) {
        h = 12;
        ampm = 'PM';
    } else if (hh === 0) {
        h = 12;
    }

    // ie: 2013-02-18, 8:35 AM	
    time = +h + ':' + min + ' ' + ampm + ',' + yyyy + '-' + mm + '-' + dd;

    return time;
}

var getHex16 = function(value) {
    // convert the register value into a human readable format for the GUI and convert to F if needed
    var result = gc.utils.getHexString(value, 16, "0x");
    return result;
};

var getHex8 = function(value) {
    // convert the register value into a human readable format for the GUI and convert to F if needed
    var result = gc.utils.getHexString(value, 8, "0x");
    return result;
};





/*
 *  Boilerplate code for creating computed data bindings
 */
document.addEventListener('gc-databind-ready', function() {
    /*
     *   Add custom computed value databindings here, using the following method:
     *
     *   function gc.databind.registry.bind(targetBinding, modelBinding, [getter], [setter]);
     *
     *   param targetBinding - single binding string or expression, or array of binding strings for multi-way binding.
     *   param modelBinding - single binding string or expression, or array of binding strings for multi-way binding.
     *   param getter - (optional) - custom getter function for computing the targetBinding value(s) based on modelBinding value(s).
     *   param setter - (optional) - custom setter function for computing the modelBinding value(s) based on targetBinding value(s).
     */

    // For example, a simple computed values based on simple expression
    // gc.databind.registry.bind('widget.id.propertyName', "targetVariable == 1 ? 'binding is one' : 'binding is not one'");

    // Or a custom two-way binding with custome getter and setter functions.  (setter is optional)  (getter only indicates one-way binding)
    // gc.databind.registry.bind('widget.id.propertyName', "targetVariable", function(value) { return value*5/9 + 32; }, function(value) { (return value-32)*9/5; });

    // Event 1 to n bindings
    /*
    gc.databind.registry.bind('widget.date.value',
        // dependant bindings needed in order to compute the date, in name/value pairs.
        {
            weekday: 'widget.dayOfWeek.selectedText',
            day: 'widget.dayOfMonth.value',
            month: 'widget.month.selectedText',
            year: 'widget.year.value'
        },
        // getter for date computation
        function(values)
        {
            // compute and return the string value to bind to the widget with id 'date'
            return values.weekday + ', ' + values.month + ' ' + values.day + ', ' + values.year;
        }
    );
	*/


    // gc.connectionManager.addEventListener('status-updated', function(event) {
    //              if(gc.connectionManager.status === 'connected'){
    //                     newconnection = true;
    //         	       var bind = gc.databind.registry.getBinding('reg.N_FACTOR_CORRECTION.NFC');
    //         				bind.setValue(8);
    //              }
    //             });

    gc.connectionManager.addEventListener('status-changed', function(event) {
                 if(gc.connectionManager.status === 'connected'){
                        newconnection = true;
            	       var bind = gc.databind.registry.getBinding('reg.N_FACTOR_CORRECTION.NFC');
            				bind.setValue(8);
                 }
                });	


	

    // gc.connectionManager.addEventListener('progress-updated', function(event) {
    //              if(gc.connectionManager.status === 'connected'){
    //                     newconnection = true;
    //         	       var bind = gc.databind.registry.getBinding('reg.N_FACTOR_CORRECTION.NFC');
    //         				bind.setValue(8);
    //              }
    //             });


//N-Factor Calculation, 
	gc.databind.registry.bind('widget.ti_widget_spinner_settings_nfactor.value','reg.N_FACTOR_CORRECTION.NFC',
        function(value) {
            // convert register value spinner value
            var result = value;
//             if(newconnection){
//                 result = 8;
// //                newconnection = false;
//             }
            if(result>127){
                result = twosComp(result);
                }
            result = (1.008*2088)/(2088+result);
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            result = Math.round(((1.008*2088)/result)-2088);
            if(newconnection){
                result = 8;
                newconnection = false;
            }
            return result;
        }
    );



///////////////////////////

	gc.databind.registry.bind('widget.ti_widget_spinner_offset.value','reg.RTEMPOFFSET_HIGH_BYTE.RTOH',
        function(value) {
            // convert register value spinner value
            var result = value;
            result = RegTemp2Deci_offset(gc.databind.registry.getBinding('reg.RTEMPOFFSET_HIGH_BYTE.RTOH').getValue(),gc.databind.registry.getBinding('reg.RTEMPOFFSET_LOW_BYTE.RTOL').getValue());
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            result = DeciTemp2RegValue_High_offset(result);
            var bindLB = gc.databind.registry.getBinding('reg.RTEMPOFFSET_LOW_BYTE.RTOL');
            var bindHB = gc.databind.registry.getBinding('reg.RTEMPOFFSET_HIGH_BYTE.RTOH');
            var resultLB = DeciTemp2RegValue_Low_offset(value);
			//bindHB.setValue(result);
			bindLB.setValue(resultLB);
			return result;
        }
    );

	gc.databind.registry.bind('widget.ti_widget_spinner_offset.value','reg.RTEMPOFFSET_LOW_BYTE.RTOL',
        function(value) {
            // convert register value spinner value
            var result = value;
            result = RegTemp2Deci_offset(gc.databind.registry.getBinding('reg.RTEMPOFFSET_HIGH_BYTE.RTOH').getValue(),gc.databind.registry.getBinding('reg.RTEMPOFFSET_LOW_BYTE.RTOL').getValue());
            return result;
        },
        function(value) {
            // Convert Spinner to Register value
            var result = value;
            result = DeciTemp2RegValue_Low_offset(result);
            var bindLB = gc.databind.registry.getBinding('reg.RTEMPOFFSET_LOW_BYTE.RTOL');
            var bindHB = gc.databind.registry.getBinding('reg.RTEMPOFFSET_HIGH_BYTE.RTOH');
            var resultHB = DeciTemp2RegValue_High_offset(value);
			bindHB.setValue(resultHB);
			//bindLB.setValue(resultLB);
            return result;
        }
    );

///////////////////////////////////////////////    
//Binding for Local temperature
	gc.databind.registry.bind('widget.ti_widget_label_settings_LTEMP.label','reg.LTEMP_LOW_BYTE.LTL',
        function(value) {
            // convert register value to object
            var result = value;
            var u2a= document.querySelector('ti-model-register').getCodec();
            var Cmd_I2C_Read = 0x64;
        	
        	
        	
        	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,0, 1])
        	u2a.readResponse(commandSent).then(function(responsePacket) {
        		var payload = responsePacket.slice(8);
        		LTEMPHB_READ = payload[0];
        	});

        	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,21, 1])
        	u2a.readResponse(commandSent).then(function(responsePacket) {
        		var payload = responsePacket.slice(8);
        		LTEMPLB_READ = payload[0]/16;
        	});
   
            
            result = RegTemp2Deci(LTEMPHB_READ,LTEMPLB_READ)
            //result = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_BYTE.LTH').getValue(),gc.databind.registry.getBinding('reg.LTEMP_LOW_BYTE.LTL').getValue());
            return result + " °" +tempScale;
        }
    );

//Binding for Remote temperature
	gc.databind.registry.bind('widget.ti_widget_label_settings_RTEMP.label','reg.RTEMP_LOW_BYTE.RTL',
        function(value) {
            
            var u2a= document.querySelector('ti-model-register').getCodec();
            var Cmd_I2C_Read = 0x64;
            // convert register value to object
            var result = value;
         
        	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,1, 1])
        	u2a.readResponse(commandSent).then(function(responsePacket) {
        		var payload = responsePacket.slice(8);
        		RTEMPHB_READ = payload[0];
        	});                    	
        	
        	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,16, 1])
        	u2a.readResponse(commandSent).then(function(responsePacket) {
        		var payload = responsePacket.slice(8);
        		RTEMPLB_READ = payload[0]/16;
        	});
           
            result = RegTemp2Deci(RTEMPHB_READ,RTEMPLB_READ)
           // result = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_BYTE.RTH').getValue(),gc.databind.registry.getBinding('reg.RTEMP_LOW_BYTE.RTL').getValue());
            return result + " °" + tempScale;
        }
    );
    
//Binding for Local Limits\\\\\\*****\\\\\\
	gc.databind.registry.bind('widget.ti_widget_slider_LTHERM.value','reg.LTEMP_THERM_LIMIT.LTTL',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_THERM_LIMIT.LTTL').getValue(),0);
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_High(result);
            return result;
        }
        
    );

//Binding for Remote Limits\\\\\\*****\\\\\\
	gc.databind.registry.bind('widget.ti_widget_slider_RTHERM.value','reg.RTEMP_THERM_LIMIT.RTTL',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_THERM_LIMIT.RTTL').getValue(),0);
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_High(result);
            return result;
        }
        
    );
//Binding for Remote Limits\\\\\\*****\\\\\\
	gc.databind.registry.bind('widget.ti_widget_slider_settings_hys.value','reg.THERM_HYS.THYS',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci_offset(gc.databind.registry.getBinding('reg.THERM_HYS.THYS').getValue(),0);
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_High_offset(result);
            return result;
        }
        
    );

//Binding for Remote Limits\\\\\\*****\\\\\\
	gc.databind.registry.bind('widget.ti_widget_slider_RALERT.value','reg.RTEMP_HIGH_LIMIT.RTLH',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT.RTLH').getValue(),gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT_LOW_BYTE.RTHLL').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_High(result);
            var bindLB = gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT_LOW_BYTE.RTHLL');
            bindLB.setValue(DeciTemp2RegValue_Low(value));            
            return result;
        }
        
    );
//Binding for Local Limits\\\\\\*****\\\\\\
	gc.databind.registry.bind('widget.ti_widget_slider_LALERT.value','reg.LTEMP_HIGH_LIMIT.LTLH',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_LIMIT.LTLH').getValue(),0);
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_High(result);
            return result;
        }
        
    );
    
////Binding for Alert Low values


//Binding for Remote Limits\\\\\\*****\\\\\\
	gc.databind.registry.bind('widget.ti_widget_slider_RALERT.valueLow','reg.RTEMP_LOW_LIMIT.RTLL',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_LOW_LIMIT.RTLL').getValue(),gc.databind.registry.getBinding('reg.RTEMP_LOW_LIMIT_LOW_BYTE.RTLLL').getValue());
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_High(result);
            var bindLB = gc.databind.registry.getBinding('reg.RTEMP_LOW_LIMIT_LOW_BYTE.RTLLL');
            bindLB.setValue(DeciTemp2RegValue_Low(value));            
            return result;
        }
        
    );
//Binding for Local Limits\\\\\\*****\\\\\\
	gc.databind.registry.bind('widget.ti_widget_slider_LALERT.valueLow','reg.LTEMP_LOW_LIMIT.LTLL',
        function(value) {
            // convert register value to object
            var result = value;
            result = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_LOW_LIMIT.LTLL').getValue(),0);
            return result;
        },
                function(value) {
            // convert object value to register
            var result = value;
            result = DeciTemp2RegValue_High(result);
            return result;
        }
        
    );

//Binding ti_widget_button_oneshot
	gc.databind.registry.bind('widget.ti_widget_button_oneshot.disabled','reg.CONFIG_REG.SD',
        function(value) {
            // convert register value to object
            var result = !value;
            return result;
        }
    );


//Consecutive alert dropdown, 1 Sample|2 Samples|3 Samples|4 Samples
	gc.databind.registry.bind('widget.ti_widget_droplist_settings_consecutivealert.selectedText','reg.CONSECUTIVE_ALERT_REG.CONSECUTIVE_ALERT',
        function(value) {
            // convert register to dropdown value
            var result = value;
            switch (result) {
                case 0:
                    result = '1 Sample';
                    break;
                case 1:
                    result = '2 Samples';
                    break;
                case 3:
                    result = '3 Samples';
                    break;
                case 7:
                    result = '4 Samples';
                    break;
                default:
                    result = '1 Sample';
                    break;
    }
            return result;
        },
        function(value) {
            // Convert dropdown to Register value
            var result = value;
            switch (result) {
                case '1 Sample':
                    result = 0;
                    break;
                case '2 Samples':
                    result = 1;
                    break;
                case '3 Samples':
                    result = 3;
                    break;
                case '4 Samples':
                    result = 7;
                    break;
                default:
                    result = 0;
                    break;
    }
            return result;
        }
    );
    
//Digital Filter alert dropdown, Averaging Off|4 Average Measurements|8 Average Measurements
	gc.databind.registry.bind('widget.ti_widget_droplist_settings_digitalfilter.selectedText','reg.DIGITAL_FILTER_CONTROL.DF_CONTROL',
        function(value) {
            // convert register to dropdown value
            var result = value;
            switch (result) {
                case 0:
                    result = 'Averaging Off';
                    break;
                case 1:
                    result = '4 Average Measurements';
                    break;
                case 2:
                    result = '8 Average Measurements';
                    break;
                default:
                    result = 'Averaging Off';
                    break;
    }
            return result;
        },
        function(value) {
            // Convert dropdown to Register value
            var result = value;
            switch (result) {
                case 'Averaging Off':
                    result = 0;
                    break;
                case '4 Average Measurements':
                    result = 1;
                    break;
                case '8 Average Measurements':
                    result = 2;
                    break;
                default:
                    result = 0;
                    break;
    }
            return result;
        }
    );   
    });
            

/*
 *  Boilerplate code for creating custom actions
 */
document.addEventListener('gc-nav-ready', function() {
    /*
     *   Add custom actions for menu items using the following api:
     *
     *   function gc.nav.registryAction(id, runable, [isAvailable], [isVisible]);
     *
     *   param id - uniquely identifies the action, and should correspond to the action property of the menuaction widget.
     *   param runable - function that performs the custom action.
     *   param isAvailable - (optional) - function called when the menu action is about to appear.  Return false to disable the action, or true to enable it.
     *   param isVisible - (optional) - function called when the menu action is about to appear.  Return false to hide the action, or true to make it visible.
     */

    // For example,
    // gc.nav.registerAction('myCustomCloseAction', function() { window.close(); }, function() { return true; }, function() { return true; });

    // Alternatively, to programmatically disable a menu action at any time use:
    // gc.nav.disableAction('myCustomCloseAction);    then enable it again using:  gc.nav.enableAction('myCustomCloseAction');

    gc.nav.registerAction('show_introduction', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_vtabcontainer.selectedIndex = 0;
            templateObj.$.ti_widget_menuitem.hideFullMenu();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });
    gc.nav.registerAction('show_registers', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_vtabcontainer.selectedIndex = 1;
            templateObj.$.ti_widget_menuitem.hideFullMenu();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });
    gc.nav.registerAction('show_motor_control', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_vtabcontainer.selectedIndex = 2;
            templateObj.$.ti_widget_menuitem.hideFullMenu();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('load_registers', function() {
        if ((templateObj) && (templateObj.$)) {
            gc.File.browseAndLoad(null, {
                bin: false
            }, function(contents, properties) {
                var regData = null;
                try {
                    regData = JSON.parse(contents);
                    if (regData) {
                        templateObj.setRegisterData(regData);
                        templateObj.$.ti_widget_eventlog_view.log("info", "Load Registers: loaded from :" + properties.localPath);
                    }
                } catch (ex) {
                    templateObj.logMsgAndNotify("error", "Load Registers: Could not parse file:" + ex, false, true);
                }

            });
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    var saveText = function(fname, text, mime) {
        var blob = new Blob([text], {
            type: mime
        });
        saveAs(blob, fname);
        return false;
    }

    var saveRegsAs = function(calledBy, regDataJson) {
        gc.File.browseAndSave(regDataJson, 'regs.json', '.json', function(result, errorInfo) {
            if (errorInfo) {
                templateObj.logMsgAndNotify("error", calledBy + " " + errorInfo, false, true);
            } else if ((result) && (result.localPath)) {
                saveAsFilePath = result.localPath;
                templateObj.$.ti_widget_eventlog_view.log("info", "Registers saved to " + result.localPath);
            }
        });
    }

    gc.nav.registerAction('save_registers', function() {
        if ((templateObj) && (templateObj.$)) {
            var regData = templateObj.getRegisterData();
            var regDataJson = JSON.stringify(regData);
            if (gc.desktop.isDesktop()) {
                if (!saveAsFilePath) {
                    saveRegsAs("Save Registers", regDataJson);
                } else {
                    gc.File.save(regDataJson, {"localPath": saveAsFilePath}, null, function(errorInfo) {
                        if (errorInfo) {
                            templateObj.logMsgAndNotify("error", "Save Registers As: " + errorInfo, false, true);
                        } else {
                            templateObj.$.ti_widget_eventlog_view.log("info", "Registers saved to " + saveAsFilePath);
                        }
                    });
                }

            } else {
                saveText("regs.json", regDataJson, 'text/plain;charset=utf-8')
                templateObj.$.ti_widget_eventlog_view.log("info", "Save Registers: regs.json file downloaded");
            }
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('save_registers_as', function() {
        if ((templateObj) && (templateObj.$)) {
            var regData = templateObj.getRegisterData();
            var regDataJson = JSON.stringify(regData);
            if (gc.desktop.isDesktop()) {
                saveRegsAs("Save Registers As", regDataJson);
            } else {
                saveText("regs.json", regDataJson, 'text/plain;charset=utf-8')
                templateObj.$.ti_widget_eventlog_view.log("info", "Save Registers As: regs.json file downloaded");
            }
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('open_log_pane', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_eventlog_view.openView();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('open_scripting_window', function() {
        window.open('app/scripting.html', '_evm_scripting');
    }, function() {
        return true;
    }, function() {
        return true;
    });
});

/*
 *  Boilerplate code for working with components in the application gist
 */


var initComplete = false;
var templateObj;
var registerModel;


// Wait for DOMContentLoaded event before trying to access the application template
var init = function() {
    templateObj = document.querySelector('#template_obj');

    // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
    // before trying to access components in the application.
    templateObj.addEventListener('dom-change', function() {
        if (initComplete) return;
        this.async(function() {
            initComplete = true;
            console.log("Application template has been stamped.");
            templateObj.$.ti_widget_toast.hideToast();
            templateObj.$.ti_widget_eventlog_view.log("info", "Application started.");
            registerModel = Polymer.dom(document).querySelector('ti-model-register');
            if (registerModel) {
                registerModel.addEventListener("usbHidModelReceivingData", function (event) {
                    templateObj.logMsgAndNotify("debug", "Receiving data from target.", false, false);
                });
            } else {
                console.log("no ti-model-register component found in this application!")
            }

            // Now that the template has been stamped, you can use 'automatic node finding' $ syntax to access widgets.
            // e.g. to access a widget with an id of 'widget_id' you can use templateObj.$.widgetId
           
            if (templateObj.$.ti_widget_tabcontainer_guide) {
                templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 0; // always start with the home page

                templateObj.$.ti_widget_label_expert.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_vtabcontainer.selectedIndex = 3;
                });

                templateObj.$.ti_widget_label_beginner.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 1;
                });

                templateObj.skipPage = function() {
                    templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 1 + templateObj.$.ti_widget_tabcontainer_guide.selectedIndex;
                };
                
                templateObj.$.ti_widget_button_config_settngs.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 2;
                });    
                
                templateObj.$.ti_widget_label_guide2_basic.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 3;
                });    
                
                templateObj.$.ti_widget_label_guide2_advanced.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_vtabcontainer.selectedIndex = 2;
                });    

                templateObj.$.ti_widget_button_go2plots.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_vtabcontainer.selectedIndex = 3;
                });

                templateObj.$.ti_widget_button_advanced_yes_fullsettings.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_vtabcontainer.selectedIndex = 2;
                });
                
                templateObj.$.ti_widget_button_basic_plots.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_vtabcontainer.selectedIndex = 3;
                });

                templateObj.$.ti_widget_button_basic_yes_fullsettings.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_vtabcontainer.selectedIndex = 2;
                });                
                
                 templateObj.$.ti_widget_button_HW_No.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 5;
                });               
                
                 templateObj.$.ti_widget_button_ts_goback.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 1;
                });
    
                templateObj.$.ti_widget_button_HW_Yes.addEventListener("click", function(event) {
                     templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 3;
                    //templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 2;
                    // templateObj.$.ti_widget_button_go2plots.visible = true;
                    // templateObj.$.ti_widget_button_config_settngs.visible = true;
                });  

                
                templateObj.$.ti_widget_button_advanced_yes_limits.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_slider_advanced_alertlimits.visible = true;
                    templateObj.$.ti_widget_label_advanced_alertlimts1.visible = true;
                    templateObj.$.ti_widget_label_advanced_thermlimits1.visible = true;
                    templateObj.$.ti_widget_slider_advanced_thermlimits.visible = true;
                    templateObj.$.ti_widget_label_advanced_RAlert_limit.visible = true;
                    templateObj.$.ti_widget_slider_advanced_RAlert_limit.visible = true;
                    templateObj.$.ti_widget_label_advanced_RTHERM_limit.visible = true;
                    templateObj.$.ti_widget_slider_advanced_RTHERM_Limit.visible = true;
                    
                });
                
                // templateObj.$.ti_widget_button_basic_yes.addEventListener("click", function(event) {
                //     templateObj.$.ti_widget_slider_basic_alertlimits.visible = true;
                //     templateObj.$.ti_widget_label_basic_alertlimts.visible = true;
                //     templateObj.$.ti_widget_label_basic_thermlimits.visible = true;
                //     templateObj.$.ti_widget_slider_basic_thermlimits.visible = true;
                //     templateObj.$.ti_widget_slider_basic_RAlert_limit.visible = true;
                //     templateObj.$.ti_widget_label_basic_RALert_Limit.visible = true;
                //     templateObj.$.ti_widget_slider_basic_RTHERM_Limit.visible = true;
                //     templateObj.$.ti_widget_label_RTHERM_Limit.visible = true;
                // });
                

                templateObj.$.ti_widget_button_advanced_plots.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_vtabcontainer.selectedIndex = 3;
                });

                templateObj.$.ti_widget_button_advanced_defaults.addEventListener("click", function(event) {
                    templateObj.$.ti_widget_checkbox_advanced_step6.checked = true;
                });
               
                // templateObj.$.ti_widget_button_defaults.addEventListener("click", function(event) {
                //     templateObj.$.ti_widget_checkbox_basicstep5.checked = true;
                // });

                templateObj.$.ti_widget_label_skip_page.addEventListener("click", templateObj.skipPage);

		// when the user changes the vtab, reset the guide back to its first page
                templateObj.$.ti_widget_vtabcontainer.addEventListener("selected_tab_changed", function(event) {
                    if (templateObj.$.ti_widget_vtabcontainer === 1) {
                        // reset the guide back to the first tab
                        templateObj.$.ti_widget_tabcontainer_guide.selectedIndex = 0;
                    }
                });
            }
            // open the eventlog viewer when the user clicks on the book icon in the status bar:
            templateObj.$.ti_widget_eventlog_view.closeView(); // ensure that view states are in sync with application
            templateObj.$.ti_widget_statusbar.addEventListener("appiconclicked", function(event) {
                templateObj.$.ti_widget_eventlog_view.toggleView();
            });

    
            // Expand vtabcontainer nav bar when user clicks on menu icon or 'Menu' label
            templateObj.toggleMenu = function(event){
                templateObj.$.ti_widget_vtabcontainer.isExpanded = !templateObj.$.ti_widget_vtabcontainer.isExpanded;
            };
            templateObj.$.ti_widget_icon_button_menu.addEventListener('click',templateObj.toggleMenu);
            templateObj.$.ti_widget_label_menu.addEventListener('click',templateObj.toggleMenu);

            if (templateObj.$.ti_widget_register_page) {
                // get the active device name from the register page
                templateObj.$.ti_widget_menubar.productName = templateObj.$.ti_widget_register_page.deviceName;

                // called when the user clicks the Write Register button:
                templateObj.$.ti_widget_register_page.addEventListener("write_reg", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user clicks the Write All Registers button:
                templateObj.$.ti_widget_register_page.addEventListener("write_regs", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user clicks the Read Register button:
                templateObj.$.ti_widget_register_page.addEventListener("read_reg", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user clicks the Read All Registers button:
                templateObj.$.ti_widget_register_page.addEventListener("read_regs", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user changes the immediate / deferred mode
                templateObj.$.ti_widget_register_page.addEventListener("update_mode_changed", function (event) {
                    var detailsObj = event.detail;
                    templateObj.$.ti_widget_eventlog_view.log("info", "request to change update mode to " + detailsObj.mode.label);
                }.bind(this));

                // called when the user changes the auto read refresh rate
                templateObj.$.ti_widget_register_page.addEventListener("auto_read_config_changed", function (event) {
                    var detailsObj = event.detail;
                    templateObj.$.ti_widget_eventlog_view.log("info", "request to change automatic read interval to " + detailsObj.autoRead.label);
                }.bind(this));
            }

            var usbHidService = gc.services['ti-service-usbhid'];
            if (usbHidService) {
                usbHidService.addEventListener('usbHidError', function(event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify("error", detailsObj.info + ": " + detailsObj.error, false, true);
                })
            }

            templateObj.getRegisterData = function() {
                var regData = {
                    signature: "oneui-register-data",
                    data: []
                }
                var regBlocks = templateObj.$.ti_widget_register_page.regBlocks;
                for (var i = 0; i < regBlocks.length; i++) {
                    var registersData = [];
                    for (var r = 0; r < regBlocks[i].registers.length; r++) {
                        var reg = regBlocks[i].registers[r];
                        var regName = reg.name.toLowerCase();
                        regName = regName.replace(/\&/g, "_");
                        var item = {
                            idx: r,
                            id: regName,
                            value: reg.value
                        }
                        registersData.push(item);
                    }
                    regData.data.push(registersData);
                }
                var strJson = JSON.stringify(regData);
                return strJson;
            };

            templateObj.setRegisterData = function(strJson) {
                var regData = JSON.parse(strJson);
                var ok = true;
                var regBlocks = templateObj.$.ti_widget_register_page._registerView.regBlocks;
                for (var b = 0; b < regBlocks.length; b++) {
                    var registersData = [];
                    for (var r = 0; r < regBlocks[b].registers.length; r++) {
                        var reg = regBlocks[b].registers[r];
                        var regName = reg.name.toLowerCase();
                        regName = regName.replace(/\&/g, "_");
                        item = regData.data[b][r];
                        if (item.id === regName) {
                            reg.value = item.value;
                            if (!templateObj.$.ti_widget_register_page.isDeferredWrite) {
                                reg.valueLastWritten = reg.value;
                                var intValue = gc.utils.getValueFromHexString("" + reg.value);
                                templateObj.$.ti_widget_register_page.writeValueToTargetRegister(intValue, null, b, r);
                            } else {
                                templateObj.$.ti_widget_register_page._registerView.refreshRegValue(b,r);
                            }
                        } else {
                            var msg = "load registers failed: register name mismatch (" + item.id + " does not match " + regName + ")";
                            templateObj.logMsgAndNotify("warning", msg, false, true);
                        }
                    }
                }
                if (templateObj.$.ti_widget_register_page.isDeferredWrite){
                    templateObj.$.ti_widget_register_page._registerView._deferredAccessCtr++; // update the page
                }
            };

            templateObj.showToastMsg = function(msgType, msg, durationInSeconds) {
                templateObj.$.ti_widget_toast.hideToast();
                templateObj.$.ti_widget_toast.message = msg;
                switch (msgType.toLowerCase()) {
                    case "error":
                        templateObj.$.ti_widget_toast.iconName = "error";
                        templateObj.$.ti_widget_toast.backgroundColor = "red";
                        break;
                    case "warning":
                        templateObj.$.ti_widget_toast.iconName = "warning";
                        templateObj.$.ti_widget_toast.backgroundColor = "orange";
                        break;
                    default:
                        templateObj.$.ti_widget_toast.iconName = "check";
                        templateObj.$.ti_widget_toast.backgroundColor = "teal";
                        break;
                }
                templateObj.$.ti_widget_toast.duration = +durationInSeconds;
                templateObj.$.ti_widget_toast.showToast();
                console.log("toast msg [" + msgType + "]: " + msg);
            };

            templateObj.logMsgAndNotify = function(msgType, msg, showInStatusBar, showInToast) {
                var iconName = templateObj.$.ti_widget_eventlog_view.iconForItem(msgType);
                if (showInStatusBar) {
                    var statusBar = gc.services['ti-widget-statusbar'];
                    if (statusBar) {
                        statusBar.statusString3 = msg;
                        statusBar.setIcon(iconName);
                    }
                }
                if (showInToast) {
                    templateObj.showToastMsg(msgType, msg, 4);
                }
                templateObj.$.ti_widget_eventlog_view.log(msgType, msg);
            };
            templateObj.$.ti_widget_label_learnmore.addEventListener("click",function(event){
                 //templateObj.$.ti_widget_label_productname.fontColor="#444";
                 templateObj.$.ti_widget_label_productdesc.fontColor="#444";
                 templateObj.$.ti_widget_label_learnmore.setAttribute('hidden',true);
                 templateObj.$.ti_widget_label_showless.removeAttribute('hidden');
                 //templateObj.$.ti_widget_vtab_home.style.backgroundColor = "white";
                 templateObj.$.ti_widget_tabcontainer.selectedIndex = 1;
            });
            templateObj.$.ti_widget_label_showless.addEventListener("click",function(event){
                 templateObj.$.ti_widget_label_productname.fontColor="white";
                 templateObj.$.ti_widget_label_productdesc.fontColor="white";
                 templateObj.$.ti_widget_label_learnmore.removeAttribute('hidden');
                 templateObj.$.ti_widget_label_showless.setAttribute('hidden',true);
                 templateObj.$.ti_widget_vtab_home.style.backgroundColor = "rgb(20, 140, 156)";
                 templateObj.$.ti_widget_tabcontainer.selectedIndex = 0;
            });
///////My Code////

            //Set I2C Frequency based on droplist
            templateObj.$.ti_widget_droplist2_i2c_freq.addEventListener("selected", function(event) {
               var u2a= document.querySelector('ti-model-register').getCodec();         // get codec
               var Cmd_I2C_Set = 1;                                                     // Command to set I2C port
               var speed = templateObj.$.ti_widget_droplist2_i2c_freq.selectedIndex;    // Speed based on droplist index: 0:100kHz, 1:400kHz, 2:10kHz
               var commandSent = u2a.sendCommandPacket(Cmd_I2C_Set, [speed, 0, 1])      // send command to set I2C, see packet definition in USB2ANY.h
            });
            
            //Implement I2C Reset using u2a.sendCommandPacket
            templateObj.$.ti_widget_button_I2C_reset.addEventListener("click", function(event) {
               var u2a= document.querySelector('ti-model-register').getCodec();
               var Cmd_I2C_Write = 2;
               var commandSent = u2a.sendCommandPacket(Cmd_I2C_Write, [0, 0, 1, 6])
            }); 
            templateObj.updateTempScale = function() {
                var origScale = tempScale;
                var labels;
                var inc;
                var max;
                var min;
                var max_off;
                var min_off;
                var max_hys;
                var min_hys;
                var inc_hys;
                var labels_hys;
                
                if (ti_widget_radio_group_advanced_CF.selectedText.toLowerCase() === "fahrenheit") {
                    tempScale = "F";
                    max_off = 230.175;
                    min_off = -230.4;                
                    max_hys = 228.6;
                    min_hys = 0;
                    inc_hys = 1.8;
                    labels_hys = '0,57.6,115.2,172.8,228.6';
                    
                    if(RangeFLAG === 0){
                    labels = F_Slider_labels_standard;
                    inc = F_Slider_increment;
                    max = F_Range_high_standard;
                    min = F_Range_low_standard;
                    }
                    else{
                    labels = F_Slider_labels;
                    inc = F_Slider_increment;
                    max = F_Range_high;
                    min = F_Range_low;
                    }
                } else {
                    tempScale = "C";
                    max_off = C_Range_high_standard;
                    min_off = -127.9375;
                    max_hys = 127;
                    min_hys = 0;
                    inc_hys = 1;
                    labels_hys = '0,16,32,48,64,80,96,112,127';
                    if(RangeFLAG === 0){
                        labels = C_Slider_labels_standard;
                        inc = C_Slider_increment;
                        max = C_Range_high_standard;
                        min = C_Range_low_standard;
                    }
                    else{
                    labels = C_Slider_labels;
                    inc = C_Slider_increment;
                    max = C_Range_high;
                    min = C_Range_low;
                    }
                }
                if (origScale !== tempScale) {
                    
                    templateObj.$.ti_widget_label_datacap_LTEMP.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_BYTE.LTH').getValue(),gc.databind.registry.getBinding('reg.LTEMP_LOW_BYTE.LTL').getValue()) + " °"+ tempScale;
                    templateObj.$.ti_widget_label_datacap_RTEMP.label  = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_BYTE.RTH').getValue(),gc.databind.registry.getBinding('reg.RTEMP_LOW_BYTE.RTL').getValue()) + " °" + tempScale;
                    templateObj.$.ti_widget_label_settings_LTEMP.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_BYTE.LTH').getValue(),gc.databind.registry.getBinding('reg.LTEMP_LOW_BYTE.LTL').getValue()) + " °" + tempScale;
                    templateObj.$.ti_widget_label_settings_RTEMP.label = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_BYTE.RTH').getValue(),gc.databind.registry.getBinding('reg.RTEMP_LOW_BYTE.RTL').getValue()) + " °" + tempScale;
					
					templateObj.$.ti_widget_slider_LTHERM.labels = labels;
                    templateObj.$.ti_widget_slider_RTHERM.labels = labels;
                    templateObj.$.ti_widget_slider_LALERT.labels = labels;
                    templateObj.$.ti_widget_slider_RALERT.labels = labels;
                    templateObj.$.ti_widget_slider_basic_alertlimits.labels = labels;
                    templateObj.$.ti_widget_slider_basic_thermlimits.labels = labels;
                    templateObj.$.ti_widget_slider_basic_RAlert_limit.labels = labels;
                    templateObj.$.ti_widget_slider_basic_RTHERM_Limit.labels = labels;
                    templateObj.$.ti_widget_slider_LTHERM_datacap.labels = labels;
                    templateObj.$.ti_widget_slider_RTHERM_datacap.labels = labels;
                    templateObj.$.ti_widget_slider_LALERT_datacap.labels = labels;
                    templateObj.$.ti_widget_slider_RALERT_datacap.labels = labels;
                    
                    
                    
					templateObj.$.ti_widget_slider_LTHERM.increment = inc_hys;
                    templateObj.$.ti_widget_slider_RTHERM.increment = inc_hys;
                    templateObj.$.ti_widget_slider_LALERT.increment = inc_hys;
                    templateObj.$.ti_widget_slider_RALERT.increment = inc;
                    templateObj.$.ti_widget_slider_basic_alertlimits.increment = inc_hys;                    
                    templateObj.$.ti_widget_slider_basic_thermlimits.increment = inc_hys;                    
                    templateObj.$.ti_widget_slider_basic_RAlert_limit.increment = inc;                    
                    templateObj.$.ti_widget_slider_basic_RTHERM_Limit.increment = inc_hys;                    
					templateObj.$.ti_widget_slider_LTHERM_datacap.increment = inc_hys;
                    templateObj.$.ti_widget_slider_RTHERM_datacap.increment = inc_hys;
                    templateObj.$.ti_widget_slider_LALERT_datacap.increment = inc_hys;
                    templateObj.$.ti_widget_slider_RALERT_datacap.increment = inc;

                    templateObj.$.ti_widget_slider_LTHERM.maxValue = max;
                    templateObj.$.ti_widget_slider_RTHERM.maxValue = max;
                    templateObj.$.ti_widget_slider_LALERT.maxValue = max;
                    templateObj.$.ti_widget_slider_RALERT.maxValue = max;
                    templateObj.$.ti_widget_slider_basic_alertlimits.maxValue = max;
                    templateObj.$.ti_widget_slider_basic_thermlimits.maxValue = max;
                    templateObj.$.ti_widget_slider_basic_RAlert_limit.maxValue = max;
                    templateObj.$.ti_widget_slider_basic_RTHERM_Limit.maxValue = max;
                    templateObj.$.ti_widget_slider_LTHERM_datacap.maxValue = max;
                    templateObj.$.ti_widget_slider_RTHERM_datacap.maxValue = max;
                    templateObj.$.ti_widget_slider_LALERT_datacap.maxValue = max;
                    templateObj.$.ti_widget_slider_RALERT_datacap.maxValue = max;

					templateObj.$.ti_widget_slider_LTHERM.minValue = min;
                    templateObj.$.ti_widget_slider_RTHERM.minValue = min;
                    templateObj.$.ti_widget_slider_LALERT.minValue = min;
                    templateObj.$.ti_widget_slider_RALERT.minValue = min;
                    templateObj.$.ti_widget_slider_basic_alertlimits.minValue = min;                    
                    templateObj.$.ti_widget_slider_basic_thermlimits.minValue = min;                    
                    templateObj.$.ti_widget_slider_basic_RAlert_limit.minValue = min;                    
                    templateObj.$.ti_widget_slider_basic_RTHERM_Limit.minValue = min;
					templateObj.$.ti_widget_slider_LTHERM_datacap.minValue = min;
                    templateObj.$.ti_widget_slider_RTHERM_datacap.minValue = min;
                    templateObj.$.ti_widget_slider_LALERT_datacap.minValue = min;
                    templateObj.$.ti_widget_slider_RALERT_datacap.minValue = min;                    
                    
                    //Offset spinner
                    templateObj.$.ti_widget_spinner_offset.minValue = min_off;
                    templateObj.$.ti_widget_spinner_offset.maxValue = max_off;
                    templateObj.$.ti_widget_spinner_offset.increment = inc;
                    //Hyst Slider
                    templateObj.$.ti_widget_slider_settings_hys.labels = labels_hys;
                    templateObj.$.ti_widget_slider_settings_hys.maxValue = max_hys;                    
                    templateObj.$.ti_widget_slider_settings_hys.increment = inc_hys;
                    graphclear();
                }

            };
    
            templateObj.updateTempScale();
            
            templateObj.$.ti_widget_radio_group_advanced_CF.addEventListener("changed", function(event) {
                templateObj.updateTempScale();
            });	
            templateObj.updateRangeScale = function() {
                var origScale = RangeFLAG;
                var labels;
                var max;
                var min;
                var max_off;
                var min_off;
                var max_hys;
                var min_hys;
                var labels_hys;
                
                if(ti_widget_checkbox_Range.checked === false) {
                    //gc.databind.registry.getBinding('reg.CONFIG_REG.RANGE').setValue(0)                    
                    RangeFLAG = 0;
                }
                else {
                    //gc.databind.registry.getBinding('reg.CONFIG_REG.RANGE').setValue(1)                    
                    RangeFLAG = 1;
                }
                if (origScale !== RangeFLAG) {
                    if (tempScale === "F") {
                        if(RangeFLAG === 0){
                        labels = F_Slider_labels_standard;
                        inc = F_Slider_increment;
                        max = F_Range_high_standard;
                        min = F_Range_low_standard;
                        }
                        else{
                        labels = F_Slider_labels;
                        inc = F_Slider_increment;
                        max = F_Range_high;
                        min = F_Range_low;
                        }
                    } else {
                        if(RangeFLAG === 0){
                        labels = C_Slider_labels_standard;
                        inc = C_Slider_increment;
                        max = C_Range_high_standard;
                        min = C_Range_low_standard;
                        }
                        else{
                        labels = C_Slider_labels;
                        inc = C_Slider_increment;
                        max = C_Range_high;
                        min = C_Range_low;
                        }
                    }
                    templateObj.$.ti_widget_slider_LTHERM.labels = labels;
                    templateObj.$.ti_widget_slider_RTHERM.labels = labels;
                    templateObj.$.ti_widget_slider_LALERT.labels = labels;
                    templateObj.$.ti_widget_slider_RALERT.labels = labels;
                    templateObj.$.ti_widget_slider_basic_alertlimits.labels = labels;
                    templateObj.$.ti_widget_slider_basic_thermlimits.labels = labels;
                    templateObj.$.ti_widget_slider_basic_RAlert_limit.labels = labels;
                    templateObj.$.ti_widget_slider_basic_RTHERM_Limit.labels = labels;
                    templateObj.$.ti_widget_slider_LTHERM_datacap.labels = labels;
                    templateObj.$.ti_widget_slider_RTHERM_datacap.labels = labels;
                    templateObj.$.ti_widget_slider_LALERT_datacap.labels = labels;
                    templateObj.$.ti_widget_slider_RALERT_datacap.labels = labels;
                    
                    templateObj.$.ti_widget_slider_LTHERM.maxValue = max;
                    templateObj.$.ti_widget_slider_RTHERM.maxValue = max;
                    templateObj.$.ti_widget_slider_LALERT.maxValue = max;
                    templateObj.$.ti_widget_slider_RALERT.maxValue = max;
                    templateObj.$.ti_widget_slider_basic_alertlimits.maxValue = max;
                    templateObj.$.ti_widget_slider_basic_thermlimits.maxValue = max;
                    templateObj.$.ti_widget_slider_basic_RAlert_limit.maxValue = max;
                    templateObj.$.ti_widget_slider_basic_RTHERM_Limit.maxValue = max;
                    templateObj.$.ti_widget_slider_LTHERM_datacap.maxValue = max;
                    templateObj.$.ti_widget_slider_RTHERM_datacap.maxValue = max;
                    templateObj.$.ti_widget_slider_LALERT_datacap.maxValue = max;
                    templateObj.$.ti_widget_slider_RALERT_datacap.maxValue = max;                    
                    

					templateObj.$.ti_widget_slider_LTHERM.minValue = min;
                    templateObj.$.ti_widget_slider_RTHERM.minValue = min;
                    templateObj.$.ti_widget_slider_LALERT.minValue = min;
                    templateObj.$.ti_widget_slider_RALERT.minValue = min;
                    templateObj.$.ti_widget_slider_basic_alertlimits.minValue = min;                    
                    templateObj.$.ti_widget_slider_basic_thermlimits.minValue = min;                    
                    templateObj.$.ti_widget_slider_basic_RAlert_limit.minValue = min;                    
                    templateObj.$.ti_widget_slider_basic_RTHERM_Limit.minValue = min;
					templateObj.$.ti_widget_slider_LTHERM_datacap.minValue = min;
                    templateObj.$.ti_widget_slider_RTHERM_datacap.minValue = min;
                    templateObj.$.ti_widget_slider_LALERT_datacap.minValue = min;
                    templateObj.$.ti_widget_slider_RALERT_datacap.minValue = min; 



                    templateObj.$.ti_widget_slider_LTHERM.value = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_THERM_LIMIT.LTTL').getValue(),0);
                    templateObj.$.ti_widget_slider_RTHERM.value = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_THERM_LIMIT.RTTL').getValue(),0);
                    templateObj.$.ti_widget_slider_LALERT.value = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_LIMIT.LTLH').getValue(),0);
                    templateObj.$.ti_widget_slider_RALERT.value = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT.RTLH').getValue(),gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT_LOW_BYTE.RTHLL').getValue());
                    //Clear Graph 
                    graphclear();
                }
            };
            
            //templateObj.updateRangeScale();            
            templateObj.$.ti_widget_checkbox_Range.addEventListener("changed", function(event) {
                templateObj.updateRangeScale();
            });                
                


			templateObj.$.ti_widget_button_oneshot.addEventListener("click", function(event) {
					var bind = gc.databind.registry.getBinding('reg.ONE_SHOT_REG.One_Shot');
					         bind.setValue(1);
                    
                    var u2a= document.querySelector('ti-model-register').getCodec();
                    var Cmd_I2C_Read = 0x64;
                    					
                    templateObj.$.ti_widget_register_page.readAllRegistersClickHdlr();
					THYS = RegTemp2Deci_offset(gc.databind.registry.getBinding('reg.THERM_HYS.THYS').getValue(),0);
                    LTHERM1HYS_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_THERM_LIMIT.LTTL').getValue(),0)-THYS;
                    RTHERM1HYS_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_THERM_LIMIT.RTTL').getValue(),0)-THYS;
                    LTHERM2HYS_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_LIMIT.LTLH').getValue(),0)-THYS;
                    RTHERM2HYS_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT.RTLH').getValue(),0)-THYS;
                    RTHERM_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_THERM_LIMIT.RTTL').getValue(),0);
                    LL_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_LOW_LIMIT.LTLL').getValue(),0);
                    LH_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_LIMIT.LTLH').getValue(),0)
                    RL_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_LOW_LIMIT.RTLL').getValue(),gc.databind.registry.getBinding('reg.RTEMP_LOW_LIMIT_LOW_BYTE.RTLLL').getValue());
                    RH_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT.RTLH').getValue(),gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT_LOW_BYTE.RTHLL').getValue());

                    	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,0, 1])
                    	u2a.readResponse(commandSent).then(function(responsePacket) {
                    		var payload = responsePacket.slice(8);
                    		LTEMPHB_READ = payload[0];
                    	});

                    	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,21, 1])
                    	u2a.readResponse(commandSent).then(function(responsePacket) {
                    		var payload = responsePacket.slice(8);
                    		LTEMPLB_READ = payload[0]/16;
                    	});
                    	
                    	
                    	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,1, 1])
                    	u2a.readResponse(commandSent).then(function(responsePacket) {
                    		var payload = responsePacket.slice(8);
                    		RTEMPHB_READ = payload[0];
                    	});                    	
                    	
                    	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,16, 1])
                    	u2a.readResponse(commandSent).then(function(responsePacket) {
                    		var payload = responsePacket.slice(8);
                    		RTEMPLB_READ = payload[0]/16;
                    	});   


                        RTEMP = RegTemp2Deci(RTEMPHB_READ,RTEMPLB_READ);
                        LTEMP = RegTemp2Deci(LTEMPHB_READ,LTEMPLB_READ);
//                    RTEMP = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_BYTE.RTH').getValue(),gc.databind.registry.getBinding('reg.RTEMP_LOW_BYTE.RTL').getValue());
//                    LTEMP = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_BYTE.LTH').getValue(),gc.databind.registry.getBinding('reg.LTEMP_LOW_BYTE.LTL').getValue());
                    
                                                       
					graphdraw();

			
            });
            
			templateObj.$.ti_widget_button_cleardata.addEventListener("click", function(event) {
                    graphclear();
            });

//Channel Container Color Fault,
    gc.databind.registry.getBinding('reg.STATUS').addStreamingListener({
        onDataReceived: function(value) {
            var local_alert_color = value;
            var remote_alert_color = value;
            var local_therm_color = value;
            var remote_therm_color = value;
            var open  = value;
            
            local_alert_color = local_alert_color & 96;
            switch (local_alert_color) {
                case 64:
                    templateObj.$.ti_widget_container47.style.backgroundColor = '#ff8080';
                    templateObj.$.ti_widget_container59.style.backgroundColor = '#ff8080';
                    
                    break;
                case 32:
                    templateObj.$.ti_widget_container47.style.backgroundColor = "#b3ffff";
                    templateObj.$.ti_widget_container59.style.backgroundColor = '#b3ffff';
                    
                    break;
                case 96:
                    templateObj.$.ti_widget_container47.style.backgroundColor = "#b3b3ff";
                    templateObj.$.ti_widget_container59.style.backgroundColor = "#b3b3ff";
                    
                    break;
                default:
                    templateObj.$.ti_widget_container47.style.backgroundColor = "#f2f2f2";
                    templateObj.$.ti_widget_container59.style.backgroundColor = "#f2f2f2";
                    break;
    }
        remote_alert_color = remote_alert_color & 24;
                switch (remote_alert_color) {
                    case 16:
                        templateObj.$.ti_widget_container51.style.backgroundColor = "#ff8080";
                        templateObj.$.ti_widget_container61.style.backgroundColor = "#ff8080";
                        break;
                    case 8:
                        templateObj.$.ti_widget_container51.style.backgroundColor = "#b3ffff";
                        templateObj.$.ti_widget_container61.style.backgroundColor = "#b3ffff";
                        break;
                    case 24:
                        templateObj.$.ti_widget_container51.style.backgroundColor = "#b3b3ff";
                        templateObj.$.ti_widget_container61.style.backgroundColor = "#b3b3ff";
                        break;                
                    case 0:
                        templateObj.$.ti_widget_container51.style.backgroundColor = "#f2f2f2";
                        templateObj.$.ti_widget_container61.style.backgroundColor = "#f2f2f2";
                        break;
                    default:
                        templateObj.$.ti_widget_container51.style.backgroundColor = "#f2f2f2";
                        templateObj.$.ti_widget_container61.style.backgroundColor = "#f2f2f2";
                        break;
        }
        
            local_therm_color = local_therm_color & 1;
            switch (local_therm_color) {
                case 0:
                    templateObj.$.ti_widget_container46.style.backgroundColor = '#f2f2f2';
                    templateObj.$.ti_widget_container58.style.backgroundColor = '#f2f2f2';
                    break;
                case 1:
                    templateObj.$.ti_widget_container46.style.backgroundColor = "#ff8080";
                    templateObj.$.ti_widget_container58.style.backgroundColor = "#ff8080";
                    break;
                default:
                    templateObj.$.ti_widget_container46.style.backgroundColor = "#f2f2f2";
                    templateObj.$.ti_widget_container58.style.backgroundColor = "#f2f2f2";
                    break;
    }
        remote_therm_color = remote_therm_color & 2;
                switch (remote_therm_color) {
                    case 0:
                        templateObj.$.ti_widget_container50.style.backgroundColor = '#f2f2f2';
                        templateObj.$.ti_widget_container60.style.backgroundColor = '#f2f2f2';
                        break;
                    case 2:
                        templateObj.$.ti_widget_container50.style.backgroundColor = "#ff8080";
                        templateObj.$.ti_widget_container60.style.backgroundColor = "#ff8080";
                        break;
                    default:
                        templateObj.$.ti_widget_container50.style.backgroundColor = "f2f2f2";
                        templateObj.$.ti_widget_container60.style.backgroundColor = "f2f2f2";
                        break;
        }
        open = open & 4;
                switch (open) {
                    case 0:
                        templateObj.$.ti_widget_container11.style.backgroundColor = '#f2f2f2';
                        templateObj.$.ti_widget_container56.style.backgroundColor = '#f2f2f2';
                        break;
                    case 4:
                        templateObj.$.ti_widget_container11.style.backgroundColor = "#ffff66";
                        templateObj.$.ti_widget_container56.style.backgroundColor = "#ffff66";
                        break;
                    default:
                        templateObj.$.ti_widget_container11.style.backgroundColor = "#f2f2f2";
                        templateObj.$.ti_widget_container56.style.backgroundColor = "#f2f2f2";
                        break;
        }
        
        }
    });
    
            //Save Chart for Scalar Graph
            templateObj.$.ti_widget_button_savechart.addEventListener("click", function(event) {
                
                //Want to print date of sample data next to heading row, need to define new date to do so.
                var today = new Date();
                var dd = today.getDate();
                var mm = today.getMonth()+1; //January is 0!
                var yyyy = today.getFullYear();
                
                if(dd<10) {
                    dd = '0'+dd
                } 
                
                if(mm<10) {
                    mm = '0'+mm
                } 
                
                today = mm + '/' + dd + '/' + yyyy;
                //End date creation

                //Print Header information for .csv file to result string
				var result = "Date," + today + "\n";
                result += "Config Reg, 0x" + gc.databind.registry.getBinding('reg.CONFIG_REG').getValue().toString(16) + "\n"; // Config Register Value
                result += "Sample #,Time,Local Temperature [" + tempScale + "],Remote Temperature [" + tempScale + "]," + "\n";  // Label Row for data + Date
                
                //strData0 holds values from scalar graph for series 0
                var strData0 = Local_Temp.y;
                var strData1 = Remote_Temp.y;
                for (var i = 0; i < strData0.length; i++) {
                    var timestamp = convertTimestamp(sampleTimeArray[i]);
                    result = result + i + ',' + timestamp + "," + strData0[i] + "," + strData1[i] + "\n";
                }
                
                //Save Excel File
                saveText("RemoteTempChart.csv", result);
            });

////ti_widget_droplist_refresh_rate  Off|As fast as possible|15ms Delay|50ms Delay|100ms Delay|500ms Delay|1s Delay
            templateObj.$.ti_widget_droplist_refresh_rate.addEventListener("selected",function(event){
                value = templateObj.$.ti_widget_droplist_refresh_rate.selectedText;
                switch (value) {
                    case "Off":
                        templateObj.$.ti_widget_register_page.autoReadValue = -1 ;
                        break;
                    case "As fast as possible":
                        templateObj.$.ti_widget_register_page.autoReadValue = 0 ;
                        break;
                       
                    case "15ms Delay":
                        templateObj.$.ti_widget_register_page.autoReadValue = 15 ;
                        break;
                        
                    case "50ms Delay":
                        templateObj.$.ti_widget_register_page.autoReadValue = 50 ;
                        break;
                       
                    case "100ms Delay":
                        templateObj.$.ti_widget_register_page.autoReadValue = 100 ;
                        break;
                        
                    case "500ms Delay":
                        templateObj.$.ti_widget_register_page.autoReadValue = 500;
                        break;                    
                    
                    case "1s Delay":
                        templateObj.$.ti_widget_register_page.autoReadValue = 1000;
                        break;
                   
                    default:
                        templateObj.$.ti_widget_register_page.autoReadValue = 100;
                        break;
        } 
                
            });

////ti_widget_droplist_refresh_rate  Off|As fast as possible|15ms Delay|50ms Delay|100ms Delay|500ms Delay|1s Delay
                templateObj.$.ti_widget_register_page.addEventListener("auto_read_config_changed", function (event) {
                value = templateObj.$.ti_widget_register_page.autoReadValue;
                switch (value) {
                    case "-1":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText =  "Off";
                        break;
                    case "0":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText =  "As fast as possible";
                        break;
                       
                    case "15":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText = 15 ;
                        break;
                        
                    case "50":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText = "50ms Delay" ;
                        break;
                       
                    case "100":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText = "100ms Delay" ;
                        break;
                        
                    case "500":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText = "500ms Delay";
                        break;                    
                    
                    case "1000":
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText = "1s Delay";
                        break;
                   
                    default:
                        templateObj.$.ti_widget_droplist_refresh_rate.selectedText = "100ms Delay";
                        break;
        } 
                
            });


            

/////PLOTLY Temperature Plot/////////////////////////////////////////////////////////////////////////////////////////
            
            var Remote_Temp = {
                x: [],
                y: [],
                mode: 'lines+markers',
                marker: {
                    color: 'purple',
                        },
                name: 'Remote Temp'
            };
            var Local_Temp = {
                x: [],
                y: [],
                mode: 'lines+markers',
                marker: {
                    color: 'green',
                        },
                name: 'Local Temp',
            };
    
            var RH_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'red',
                        },
                name: 'Remote High Limit'
            };
            var RL_LIMIT= {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'blue',
                        },
                name: 'Remote Low Limit'
            };
            var LH_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'darkred',
                        },
                name: 'Local High Limit'
            };
            var LL_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'darkblue',
                        },
                name: 'Local Low Limit'
                
            };

            var RTHERM_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'orangered',
                        },
                name: 'Remote Therm Limit'
            };
            var LTHERM_LIMIT = {
                x: [],
                y: [],
                mode: 'lines',
                marker: {
                    color: 'maroon',
                        },
                name: 'Local Therm Limit'
            };
            var LTHERM1_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'maroon',
                        },
                name: 'Local Therm Hys'
            };            
            var LTHERM2_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'darkred',
                        },
                name: 'Local Therm2 Hys'
            };            
            var RTHERM1_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'orangered',
                        },
                name: 'Remote Therm Hys'
            };            
            var RTHERM2_HYS = {
                x: [],
                y: [],
                mode: 'markers',
                marker: {
                    color: 'red',
                        },
                name: 'Remote Therm Hys'
            };            

            templateObj.$.ti_widget_plot_temperature.data = [Remote_Temp,Local_Temp,RH_LIMIT,RL_LIMIT,LH_LIMIT,LL_LIMIT,RTHERM_LIMIT,LTHERM_LIMIT,LTHERM1_HYS,LTHERM2_HYS,RTHERM1_HYS,RTHERM2_HYS];
            templateObj.$.ti_widget_plot_temperature.layout = {
              width: 500,
              height: 500,
                margin: {
                    t: 0
                },
                xaxis: {title: 'Samples',showticklabels: false,ticks: '' },
                yaxis: {title: 'Temperature',showticklabels: true,ticks: ''}
            };

  	        window.addEventListener('resize', (e) => {
  	            let rect = templateObj.$.ti_widget_plot_temperature.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature.relayout({width: rect? rect.width:0, height: rect? rect.height:0});
  	        });
            
            templateObj.$.ti_widget_checkbox_visible.addEventListener("changed", function(event) {

  	            let rect = templateObj.$.ti_widget_plot_temperature.getClientRects()[0];
  	            templateObj.$.ti_widget_plot_temperature.relayout({width: rect? rect.width:0, height: rect? rect.height:0});
            });   
            
            var THYS = RegTemp2Deci_offset(gc.databind.registry.getBinding('reg.THERM_HYS.THYS').getValue(),0)

        //     var u2a= document.querySelector('ti-model-register').getCodec();
        //     var Cmd_I2C_Read = 0x64;


        // 	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,0, 1])
        // 	u2a.readResponse(commandSent).then(function(responsePacket) {
        // 		var payload = responsePacket.slice(8);
        // 		LTEMPHB_READ = payload[0];
        // 	});

        // 	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,21, 1])
        // 	u2a.readResponse(commandSent).then(function(responsePacket) {
        // 		var payload = responsePacket.slice(8);
        // 		LTEMPLB_READ = payload[0]/16;
        // 	});
        	
        	
        // 	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,1, 1])
        // 	u2a.readResponse(commandSent).then(function(responsePacket) {
        // 		var payload = responsePacket.slice(8);
        // 		RTEMPHB_READ = payload[0];
        // 	});                    	
        	
        // 	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,16, 1])
        // 	u2a.readResponse(commandSent).then(function(responsePacket) {
        // 		var payload = responsePacket.slice(8);
        // 		RTEMPLB_READ = payload[0]/16;
        // 	});   


        //     RTEMP = RegTemp2Deci(RTEMPHB_READ,RTEMPLB_READ);
        //     LTEMP = RegTemp2Deci(LTEMPHB_READ,LTEMPLB_READ);
            
            var LTEMP = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_BYTE.LTH').getValue(),gc.databind.registry.getBinding('reg.LTEMP_LOW_BYTE.LTL').getValue());
            var RTEMP = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_BYTE.RTH').getValue(),gc.databind.registry.getBinding('reg.RTEMP_LOW_BYTE.RTL').getValue());
            var RH_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT.RTLH').getValue(),gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT_LOW_BYTE.RTHLL').getValue());
            var RL_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_LOW_LIMIT.RTLL').getValue(),gc.databind.registry.getBinding('reg.RTEMP_LOW_LIMIT_LOW_BYTE.RTLLL').getValue());
            var LH_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_LIMIT.LTLH').getValue(),0);
            var LL_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_LOW_LIMIT.LTLL').getValue(),0);
            var RTHERM_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_THERM_LIMIT.RTTL').getValue(),0);
            var LTHERM_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_THERM_LIMIT.LTTL').getValue(),0);    
            var LTHERM1HYS_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_THERM_LIMIT.LTTL').getValue(),0)-THYS;
            var RTHERM1HYS_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_THERM_LIMIT.RTTL').getValue(),0)-THYS;
            var LTHERM2HYS_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_LIMIT.LTLH').getValue(),0)-THYS;
            var RTHERM2HYS_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT.RTLH').getValue(),0)-THYS;            
            
            gc.databind.registry.getBinding('reg.LTEMP_THERM_LIMIT.LTTL').addStreamingListener({
                onDataReceived: function(value) {

                    var u2a= document.querySelector('ti-model-register').getCodec();
                    var Cmd_I2C_Read = 0x64;


                    THYS = RegTemp2Deci_offset(gc.databind.registry.getBinding('reg.THERM_HYS.THYS').getValue(),0)
                    
                    	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,0, 1])
                    	u2a.readResponse(commandSent).then(function(responsePacket) {
                    		var payload = responsePacket.slice(8);
                    		LTEMPHB_READ = payload[0];
                    	});

                    	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,21, 1])
                    	u2a.readResponse(commandSent).then(function(responsePacket) {
                    		var payload = responsePacket.slice(8);
                    		LTEMPLB_READ = payload[0]/16;
                    	});
                    	
                    	
                    	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,1, 1])
                    	u2a.readResponse(commandSent).then(function(responsePacket) {
                    		var payload = responsePacket.slice(8);
                    		RTEMPHB_READ = payload[0];
                    	});                    	
                    	                    	
                    	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,1, 1])
                    	u2a.readResponse(commandSent).then(function(responsePacket) {
                    		var payload = responsePacket.slice(8);
                    		RTEMPHB_READ = payload[0];
                    	});                    	
                    	
                    	
                    	var commandSent = u2a.sendCommandPacket(Cmd_I2C_Read, [0, 76,16, 1])
                    	u2a.readResponse(commandSent).then(function(responsePacket) {
                    		var payload = responsePacket.slice(8);
                    		RTEMPLB_READ = payload[0]/16;
                    		RTEMP = RegTemp2Deci(RTEMPHB_READ,RTEMPLB_READ);
                            LTEMP = RegTemp2Deci(LTEMPHB_READ,LTEMPLB_READ);
                    	});   
                    
                    // RTEMP = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_BYTE.RTH').getValue(),gc.databind.registry.getBinding('reg.RTEMP_LOW_BYTE.RTL').getValue());
                    // LTEMP = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_BYTE.LTH').getValue(),gc.databind.registry.getBinding('reg.LTEMP_LOW_BYTE.LTL').getValue());
                     
                    

                    
                    
                    
                    
                    RL_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_LOW_LIMIT.RTLL').getValue(),gc.databind.registry.getBinding('reg.RTEMP_LOW_LIMIT_LOW_BYTE.RTLLL').getValue());
                    RH_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT.RTLH').getValue(),gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT_LOW_BYTE.RTHLL').getValue());
                    LH_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_LIMIT.LTLH').getValue(),0);                   
                    LL_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_LOW_LIMIT.LTLL').getValue(),0);                   
                    RTHERM_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_THERM_LIMIT.RTTL').getValue(),0);                   
                   
                    LTHERM_LIMIT_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_THERM_LIMIT.LTTL').getValue(),0);
                    /// update Therm Hyst plots
                    LTHERM1HYS_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_THERM_LIMIT.LTTL').getValue(),0)-THYS;
                    RTHERM1HYS_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_THERM_LIMIT.RTTL').getValue(),0)-THYS;
                    LTHERM2HYS_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.LTEMP_HIGH_LIMIT.LTLH').getValue(),0)-THYS;
                    RTHERM2HYS_data = RegTemp2Deci(gc.databind.registry.getBinding('reg.RTEMP_HIGH_LIMIT.RTLH').getValue(),0)-THYS;                     
                   
                   
                    
                
                   
                   
                    ////draw graph
                    if(!templateObj.$.ti_widget_checkbox_Shutdown.checked){
                    graphdraw();
                    }
                } 
            });

            templateObj.$.ti_widget_plot_temperature.config = config = {
                'linkText': "Temperature",
                'scrollZoom': true,
                'displayModeBar': true,
                'editable': true
            };
            //templateObj.$.ti_widget_plot_temperature.redraw();
            var cnt = 0;

            var graphdraw = function() {
                if(gc.connectionManager.status === 'connected'){
                    
                    var rect = templateObj.$.ti_widget_plot_temperature.getClientRects()[0];
                    if(templateObj.$.ti_widget_vtabcontainer.selectedIndex === 3){
                    templateObj.$.ti_widget_plot_temperature.relayout({width: rect? rect.width:0, height: rect? rect.height:0});
                    }
                cnt++;
                if(cnt>templateObj.$.ti_widget_droplist_samples.selectedText){
                    while(templateObj.$.ti_widget_droplist_samples.selectedText <= Remote_Temp.x.length ){
                        Remote_Temp.x.shift();
                        Local_Temp.x.shift();
                        RH_LIMIT.x.shift();
                        RL_LIMIT.x.shift();
                        LH_LIMIT.x.shift();
                        LL_LIMIT.x.shift();
                        RTHERM_LIMIT.x.shift();
                        LTHERM_LIMIT.x.shift();
                        LTHERM1_HYS.x.shift();
                        RTHERM1_HYS.x.shift();
                        LTHERM2_HYS.x.shift();
                        RTHERM2_HYS.x.shift();
                        //update y values
                        Remote_Temp.y.shift();
                        Local_Temp.y.shift();
                        RH_LIMIT.y.shift();
                        RL_LIMIT.y.shift();
                        LH_LIMIT.y.shift();
                        LL_LIMIT.y.shift();
                        RTHERM_LIMIT.y.shift();
                        LTHERM_LIMIT.y.shift();
                        LTHERM1_HYS.y.shift();
                        RTHERM1_HYS.y.shift();
                        LTHERM2_HYS.y.shift();
                        RTHERM2_HYS.y.shift();
                        /// get date
                        var today = new Date();
                        sampleTimeArray.shift();                    
                    }
                }
                Remote_Temp.x.push(cnt);
                Local_Temp.x.push(cnt);
                RH_LIMIT.x.push(cnt);
                RL_LIMIT.x.push(cnt);
                LH_LIMIT.x.push(cnt);
                LL_LIMIT.x.push(cnt);
                RTHERM_LIMIT.x.push(cnt);
                LTHERM_LIMIT.x.push(cnt);
                LTHERM1_HYS.x.push(cnt);
                RTHERM1_HYS.x.push(cnt);
                LTHERM2_HYS.x.push(cnt);
                RTHERM2_HYS.x.push(cnt);               
                
                
                //update y values
                Remote_Temp.y.push(RTEMP);
                Local_Temp.y.push(LTEMP);
                RH_LIMIT.y.push(RH_LIMIT_data);
                RL_LIMIT.y.push(RL_LIMIT_data);
                LH_LIMIT.y.push(LH_LIMIT_data);
                LL_LIMIT.y.push(LL_LIMIT_data);
                RTHERM_LIMIT.y.push(RTHERM_LIMIT_data);
                LTHERM_LIMIT.y.push(LTHERM_LIMIT_data);
                LTHERM1_HYS.y.push(LTHERM1HYS_data);
                RTHERM1_HYS.y.push(RTHERM1HYS_data);
                LTHERM2_HYS.y.push(LTHERM2HYS_data);
                RTHERM2_HYS.y.push(RTHERM2HYS_data);
                ///get date
                var today = new Date();
                sampleTimeArray.push(today.getTime());

                 switch (templateObj.$.ti_widget_droplist_graph.selectedText) {
                                case "Temperature Only":
                                    templateObj.$.ti_widget_plot_temperature.data = [Remote_Temp,Local_Temp];
                                    break;
                                case "Temperature and Thresholds":
                                    if(templateObj.$.ti_widget_checkbox_settings_Alert_Therm.checked){
                                    templateObj.$.ti_widget_plot_temperature.data = [Remote_Temp,Local_Temp,RH_LIMIT,RL_LIMIT,LH_LIMIT,LL_LIMIT,RTHERM_LIMIT,LTHERM_LIMIT,LTHERM1_HYS,RTHERM1_HYS,LTHERM2_HYS,RTHERM2_HYS];
                                    }
                                    else{
                                    templateObj.$.ti_widget_plot_temperature.data = [Remote_Temp,Local_Temp,RH_LIMIT,RL_LIMIT,LH_LIMIT,LL_LIMIT,RTHERM_LIMIT,LTHERM_LIMIT,LTHERM1_HYS,RTHERM1_HYS];
                                    }
                                    break;
                                case "Local Only":
                                    if(templateObj.$.ti_widget_checkbox_settings_Alert_Therm.checked){
                                    templateObj.$.ti_widget_plot_temperature.data = [Local_Temp,LH_LIMIT,LL_LIMIT,LTHERM_LIMIT,LTHERM1_HYS,LTHERM2_HYS];
                                        }
                                    else{
                                    templateObj.$.ti_widget_plot_temperature.data = [Local_Temp,LH_LIMIT,LL_LIMIT,LTHERM_LIMIT,LTHERM1_HYS];
                                    }
                                    break;
                                case "Remote Only":
                                   if(templateObj.$.ti_widget_checkbox_settings_Alert_Therm.checked){
                                        templateObj.$.ti_widget_plot_temperature.data = [Remote_Temp,RH_LIMIT,RL_LIMIT,RTHERM_LIMIT,RTHERM1_HYS,RTHERM2_HYS];                                        
                                    }
                                    else{
                                    templateObj.$.ti_widget_plot_temperature.data = [Remote_Temp,RH_LIMIT,RL_LIMIT,RTHERM_LIMIT,RTHERM1_HYS];
                                    }
                                    break;
                                default:
                                    templateObj.$.ti_widget_plot_temperature.data = [Remote_Temp,Local_Temp];
                                    break;
                    }
                templateObj.$.ti_widget_plot_temperature.redraw();
                }
            };


            
            var  graphclear = function() {
                cnt = 0;
                Remote_Temp.x = [];
                Local_Temp.x = [];
                RH_LIMIT.x = [];
                RL_LIMIT.x = [];
                LH_LIMIT.x = [];
                LL_LIMIT.x = [];
                RTHERM_LIMIT.x = [];
                LTHERM_LIMIT.x = [];
                LTHERM1_HYS.x = [];
                RTHERM1_HYS.x = [];
                LTHERM2_HYS.x = [];
                RTHERM2_HYS.x = [];
                //update y values
                Remote_Temp.y = [];
                Local_Temp.y = [];
                RH_LIMIT.y = [];
                RL_LIMIT.y = [];
                LH_LIMIT.y = [];
                LL_LIMIT.y = [];
                RTHERM_LIMIT.y = [];
                LTHERM_LIMIT.y = [];
                LTHERM1_HYS.y = [];
                RTHERM1_HYS.y = [];
                LTHERM2_HYS.y = [];
                RTHERM2_HYS.y = [];
                sampleTimeArray = [];
            };
/////PLOTLY Temperature Plot/////////////////////////////////////////////////////////////////////////////////////////

        }, 1);

    });
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
} else {
    document.addEventListener('DOMContentLoaded', init);
}